<?php
/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */
//namespace JustKnit\Processors\ClientLogin;
//namespace MODX\Revolution\Processors;
namespace JustKnit\Processors\Register;

use MODX\Revolution\Processors\Security\Login;
use MODX\Revolution\modX;
use MODX\Revolution\modContext;
use MODX\Revolution\Processors\Processor;
use MODX\Revolution\modUser;
use MODX\Revolution\modUserProfile;
use MODX\Revolution\modUserSetting;
use MODX\Revolution\Processors\ProcessorResponse;
use JustKnit\Processors\Register\Base;
//class ClientLogin extends modSecurityLoginProcessor {
//class ClientLogin extends Base {
//class ClientLogin extends Login {

//class ClientLogin extends Base {
//$modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] Hurra, ClientLogin wird geladen');
class ClientLogin extends Login {
    /**
     * {@inheritDoc}
     *
     * @return bool|null|string
     */

    public function getUser() {

//    $this->username = $this->fields['username'];
//        $props = $this->getProperties();
//        $this->username = $props['username'];

//$this->modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] Hurra, getUser() wird ausgeführt-01'. print_r($props,1) );

        // Only accept login via email address if it exists only once!
        $count = $this->modx->getCount('modUserProfile', array(
            'email' => $this->username,
        ));
        if ($count > 1) {
            $criteria = array ('modUser.username' => $this->username);
        } else {
            $criteria = array(
                array('modUser.username' => $this->username),
                array('OR:Profile.email:=' => $this->username)
            );
        }
//$this->modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] Hurra, getUser() wird ausgeführt02  $count: '. $count );

        /** @var $user modUser */

        $this->user = $this->modx->getObjectGraph('modUser', '{"Profile":{},"UserSettings":{}}', $criteria);
//$this->modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] Hurra, getUser() wird ausgeführt'. print_r($criteria,1) );
    if ($this->user) {
    foreach ($this->user as $obj) {
//        $out = $obj->toArray();
//        $out['username'] = $obj->get('username');
//        $this->modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] Hurra, getUser() wird ausgeführt-03 JAA!');
    }}
        return $this->fireOnUserNotFoundEvent();
    }


}
//return 'ClientLogin';

